//--------------------------------------------------------------------------- 
#include <vcl.h>
#pragma hdrstop

#include "AlphaBlendedSplashREG.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
#define COPYRIGHTNOTICE "Copyright  1999 - 2001 Saw Joo Heng"
#define VERSION "2.20"
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TAlphaBlendedSplash *)
{
        new TAlphaBlendedSplash(NULL);
}
//---------------------------------------------------------------------------
__fastcall TAlphaBlendedSplash::TAlphaBlendedSplash(TComponent* Owner)
        : TComponent(Owner)
{
  FDelay=DEFAULTDELAY;
  FPauseInterval=DEFAULTPAUSEINTERVAL;
  FMaxOpacity=DEFAULTMAXOPACITY;
  FMinOpacity=DEFAULTMINOPACITY;
  AlphaBlenderForm = new TAlphaBlenderForm(NULL);
  FPicture = new Graphics::TBitmap;
  FPictureMMX = new Graphics::TBitmap;
}
//---------------------------------------------------------------------------
__fastcall TAlphaBlendedSplash::~TAlphaBlendedSplash()
{
  delete FPicture;
  delete FPictureMMX;
  delete AlphaBlenderForm;
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetNULL(AnsiString Value)
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAlphaBlendedSplash::GetCopyright()
{
  return AnsiString(COPYRIGHTNOTICE);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAlphaBlendedSplash::GetVersion()
{
  return AnsiString(VERSION);
}
//---------------------------------------------------------------------------
int __fastcall TAlphaBlendedSplash::GetDelay()
{
  return FDelay;
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetDelay(int Delay)
{
  if (Delay<=0)
  {
    ShowMessage("Delay value must be at least 1.");
  }
  else
  {
    FDelay=Delay;
  }
}
//---------------------------------------------------------------------------
int __fastcall TAlphaBlendedSplash::GetMaxOpacity()
{
  return FMaxOpacity;
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetMaxOpacity(int MaxOpacity)
{
  if ((MaxOpacity>255) || (MaxOpacity<0))
  {
    ShowMessage("Value must be between 0 and 255.");
  }
  else
  {
    FMaxOpacity=MaxOpacity;
    if (FMaxOpacity<FMinOpacity)
      FMaxOpacity=FMinOpacity;
  }
}
//---------------------------------------------------------------------------
int __fastcall TAlphaBlendedSplash::GetMinOpacity()
{
  return FMinOpacity;
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetMinOpacity(int MinOpacity)
{
  if ((MinOpacity>255) || (MinOpacity<0))
  {
    ShowMessage("Value must be between 0 and 255.");
  }
  else
  {
    FMinOpacity=MinOpacity;
    if (FMinOpacity>FMinOpacity)
      FMinOpacity=FMaxOpacity;
  }
}
//---------------------------------------------------------------------------
int __fastcall TAlphaBlendedSplash::GetPauseInterval()
{
  return FPauseInterval;
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetPauseInterval(int PauseInterval)
{
  FPauseInterval=PauseInterval;
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetPicture(Graphics::TBitmap *Picture)
{
  FPicture->Assign(Picture);
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::SetPictureMMX(Graphics::TBitmap *Picture)
{
  FPictureMMX->Assign(Picture);
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::BlendIn()
{
  AlphaBlenderForm->Picture=FPicture;
  AlphaBlenderForm->PictureMMX=FPictureMMX;
  AlphaBlenderForm->Delay=FDelay;
  AlphaBlenderForm->MaxOpacity=(unsigned short)FMaxOpacity;
  AlphaBlenderForm->MinOpacity=(unsigned short)FMinOpacity;
  AlphaBlenderForm->PauseInterval=FPauseInterval;
  AlphaBlenderForm->Show();
  while ((AlphaBlenderForm->Blending)&&(!AlphaBlenderForm->Error))
    Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TAlphaBlendedSplash::BlendOut()
{
  AlphaBlenderForm->Hide();

  unsigned start_cnt=GetTickCount();
  unsigned end_cnt;

  do
  {
    end_cnt=GetTickCount();
  }while(end_cnt-start_cnt<500);

}
//---------------------------------------------------------------------------
namespace Alphablendedsplashreg
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TAlphaBlendedSplash)};
                 RegisterComponents("Grasomus", classes, 0);
        }
}
//---------------------------------------------------------------------------
