//---------------------------------------------------------------------------
#ifndef AlphaBlendedSplashREGH
#define AlphaBlendedSplashREGH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "AlphaBlender.h"
//---------------------------------------------------------------------------
#define DEFAULTDELAY 3
#define DEFAULTPAUSEINTERVAL 500
#define DEFAULTMAXOPACITY 255
#define DEFAULTMINOPACITY 0
//---------------------------------------------------------------------------
class PACKAGE TAlphaBlendedSplash : public TComponent
{
private:
        TAlphaBlenderForm *AlphaBlenderForm;
        Graphics::TBitmap *FPicture;
        Graphics::TBitmap *FPictureMMX;
        int FDelay;
        int FPauseInterval;
        int FMaxOpacity;
        int FMinOpacity;
        bool FActiveBackground;
        void __fastcall SetNULL(AnsiString Value);
        AnsiString __fastcall GetCopyright();
        AnsiString __fastcall GetVersion();
        void __fastcall SetPicture(Graphics::TBitmap *Picture);
        void __fastcall SetPictureMMX(Graphics::TBitmap *Picture);
        int __fastcall GetDelay();
        void __fastcall SetDelay(int Delay);
        int __fastcall GetPauseInterval();
        void __fastcall SetPauseInterval(int PauseInterval);
        int __fastcall GetMaxOpacity();
        void __fastcall SetMaxOpacity(int MaxOpacity);
        int __fastcall GetMinOpacity();
        void __fastcall SetMinOpacity(int MinOpacity);
protected:
public:
        __fastcall TAlphaBlendedSplash(TComponent* Owner);
        __fastcall ~TAlphaBlendedSplash();
        void __fastcall BlendIn();
        void __fastcall BlendOut();
__published:
        __property AnsiString Copyright = {read=GetCopyright, write=SetNULL};
        __property AnsiString Version = {read=GetVersion, write=SetNULL};
        __property int Delay = {read=GetDelay, write=SetDelay, default=DEFAULTDELAY};
        __property int PauseInterval = {read=GetPauseInterval, write=SetPauseInterval, default=DEFAULTPAUSEINTERVAL};
        __property Graphics::TBitmap * Picture = {read=FPicture, write=SetPicture};
        __property Graphics::TBitmap * PictureMMX = {read=FPictureMMX, write=SetPictureMMX};
        __property int MaxOpacity = {read=GetMaxOpacity, write=SetMaxOpacity, default=DEFAULTMAXOPACITY};
        __property int MinOpacity = {read=GetMinOpacity, write=SetMinOpacity, default=DEFAULTMINOPACITY};
};
//---------------------------------------------------------------------------
#endif
